//ALEXANDER BLANCO HUELMOS
//UNIVERSIDAD DE VALLADOLID
//GRADO EN INGENIERÍA ELECTRÓNICA INDUSTRIAL Y AUTOMÁTICA
//TFG: SITEMA DE ALARMA PARA VIVIENDA AISLADA
//CURSO 2022-2023


//Incluimos la librerías necesarias:
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

//Declaramos la pantalla LCD:
LiquidCrystal_I2C lcd(0x27,16,2); 

//Definimos el estado de los relén ON/OFF:
#define RELAY_ON 1
#define RELAY_OFF 0

//Asignamos los pines de los relés
const int RELE_1=6; //Rele válvula de gas
const int RELE_2=7; //Relé alarma de incendios
const int RELE_3=8; //Rele válvula de agua
const int RELE_4=9;  //Relé alarma de intrusos

//Asignamos pines para llevar la señal a la placa NodeMCU:
const int GMAIL_CO=11;  //Alarma por monóxido de carbono
const int GMAIL_IN=12;  //Alarma por incendio
const int GMAIL_AG=13;  //Alarma por innundación

//Definimos los sensores analógicos (simulados con potenciómetros):

const int sens_monox= A0; //Sensor CO
int lectura_monox;
int con_monox;

const int sens_co2= A1; //Sensor CO2
int lectura_co2;
int con_co2;

const int sens_agua= A2; //Sensor Agua
int lectura_agua;
int con_agua;

//Definimos los pulsadores:
const int BOTON_1=2;
const int BOTON_2=3;
const int BOTON_3=4;
const int BOTON_4=5;
const int PIR=10;
int detector=0;

//Inicializamos valores de variables:
int encender_1= 0;
int estado_1 = 0;
int anterior_1 = 0;
int encender_2 = 0;
int anterior_2 = 0;
int estado_2 = 0;
int encender_3 = 0;
int anterior_3 = 0;
int estado_3 = 0;
int encender_4 = 0;
int anterior_4 = 0;
int estado_4 = 0;

void setup(){
//Iniciamos comunicación serial:
Serial.begin(9600);

//Inicializamos pantalla led
lcd.init();
lcd.backlight();

//Definimos entradas y salidas y escribimos en ellas valores iniciales:
pinMode(RELE_1,OUTPUT);
pinMode(RELE_2,OUTPUT);
pinMode(RELE_3,OUTPUT);
pinMode(RELE_4,OUTPUT);
pinMode(GMAIL_CO,OUTPUT);
pinMode(GMAIL_IN,OUTPUT);
pinMode(GMAIL_AG,OUTPUT);
pinMode(BOTON_1,INPUT);
pinMode(BOTON_2,INPUT);
pinMode(BOTON_3,INPUT);
pinMode(BOTON_4,INPUT);
pinMode(PIR,INPUT);
digitalWrite(RELE_1,RELAY_OFF);
digitalWrite(RELE_2,RELAY_OFF);
digitalWrite(RELE_3,RELAY_OFF);
digitalWrite(RELE_4,RELAY_OFF);
digitalWrite(GMAIL_CO,LOW);
digitalWrite(GMAIL_IN,LOW);
digitalWrite(GMAIL_AG,LOW);
}
void loop(){
 //Monitoreo de sensor de CO y activación de relé de salida con muestra de datos en LCD:
lectura_monox=analogRead(A0);
con_monox=map(lectura_monox,0,1023,0,2000);

  if(con_monox >=1000){
  encender_1=1;
  Serial.println("monoxido");
  lcd.setCursor(0,0);
  lcd.print("!ALERTA POR CO !");
  lcd.setCursor(0,1);
  lcd.print("Nivel CO:");
  lcd.print(con_monox);
  lcd.print("   ");
  digitalWrite(GMAIL_CO,HIGH);
 
  }
  if(con_monox <=1000 && con_co2 <=1000 && con_agua <=1000 && encender_4==LOW){
    lcd.setCursor(0,0);
    lcd.print("Niveles normales");
    lcd.setCursor(0,1);
    lcd.print("----------------");
    }
   
//Monitoreo de sensor de CO2 y activación de relé de salida con muestra de datos en LCD:  
lectura_co2=analogRead(A1);
con_co2=map(lectura_co2,0,1023,0,2000);

if(con_co2 >=1000){
  encender_3=1;
  Serial.print("co2");
  lcd.setCursor(0,0);
  lcd.print("ALERTA POR CO2 !");
  lcd.setCursor(0,1);
  lcd.print("Nivel CO2:");
  lcd.print(con_co2);
  lcd.print("   ");
  digitalWrite(GMAIL_IN,HIGH);
  
  }
  
  
lectura_agua=analogRead(A2);
con_agua=map(lectura_agua,0,1023,0,2000);

//Monitoreo de sensor de agua y activación de relé de salida con muestra de datos en LCD:  
if(con_agua >=1000){
  encender_2=1;
  Serial.print("agua");
  lcd.setCursor(0,0);
  lcd.print("ALERTA POR AGUA !");
  lcd.setCursor(0,1);
  lcd.print("Nivel AGUA:");
  lcd.print(con_agua);
  lcd.print("   ");
  digitalWrite(GMAIL_AG,HIGH);
  
  
  }

//Monitoreo de sensor PIR y activación de relé de salida con muestra de datos en LCD:  

  detector=digitalRead(PIR);
if(detector==HIGH){
  encender_4=1;
 
  }

estado_1 = digitalRead(BOTON_2);

if  (estado_1 && anterior_1 == 0){

encender_1 = 1 - encender_1;
delay(200);
}
anterior_1 = estado_1;
if(encender_1)
{
  digitalWrite(RELE_1,RELAY_ON);
   
}
else
{
  digitalWrite(RELE_1,RELAY_OFF);
  digitalWrite(GMAIL_CO,LOW);

}


estado_2 = digitalRead(BOTON_1);

if  (estado_2 && anterior_2 == 0){

encender_2 = 1 - encender_2;
delay(200);
}
anterior_2 = estado_2;
if(encender_2)
{
  digitalWrite(RELE_2,RELAY_OFF);
}
else
{
  digitalWrite(RELE_2,RELAY_ON);
  digitalWrite(GMAIL_AG,LOW);
}

estado_3 = digitalRead(BOTON_3);

if  (estado_3 && anterior_3 == 0){

encender_3 = 1 - encender_3;
delay(200);
}
anterior_3 = estado_3;
if(encender_3)
{
  digitalWrite(RELE_3,RELAY_OFF);
}
else
{
  digitalWrite(RELE_3,RELAY_ON);
  digitalWrite(GMAIL_IN,LOW);
}

estado_4 = digitalRead(BOTON_4);

if  (estado_4 && anterior_4 == 0){

encender_4 = 1 - encender_4;
delay(200);
}
anterior_4 = estado_4;
if(encender_4)
{
  digitalWrite(RELE_4,RELAY_ON);
    lcd.setCursor(0,0);
    lcd.print("-----ALARMA-----");
    lcd.setCursor(0,1);
    lcd.print("----intruso-----");
}
else
{
  digitalWrite(RELE_4,RELAY_OFF);
}


} 

  
