//ALEXANDER BLANCO HUELMOS
//UNIVERSIDAD DE VALLADOLID
//GRADO EN INGENIERÍA ELECTRÓNICA INDUSTRIAL Y AUTOMÁTICA
//TFG: SITEMA DE ALARMA PARA VIVIENDA AISLADA
//CURSO 2022-2023
//CÓDIGO NODEMCU V3

//Incluimos librería para habilitar conexión wifi
#include <ESP8266WiFi.h>
#include <SoftwareSerial.h>


//Conexión a wifi con nombre y contraseña de la red:
const char* ssid = "Redmi_alex";
const char* password = "12345678";

//Definimos pines:
int CO = 14;
int IN = 12;
int AG = 13;
int AL = 15;

//Variable para uso en la APP:
const char* apiKey = "o.hRuf8fkfLced20mxw3mJYCVipVDfHbsK";

void setup() {

  //Serial.begin(115200);
  //comienza la comunicación serial con Arduino y Arduino IDE (Serial Monitor)
  Serial.begin(9600);
  
  //Comienza la comunicacion serial con Arduino y SIM800L
  //mySerial.begin(115200);

  //serial.println("Initializing..."); 
  //delay(1000);

  //mySerial.println("AT"); //una vez que las pruebas son exitosas regresará un OK 
  //updateSerial();

  WiFi.begin(ssid,password);

  Serial.print("Conectando");
  while(WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(100);
  }

  Serial.println("Conectado");
  Serial.print("Direccion IP: ");
  Serial.println(WiFi.localIP());
//Definimos entradas y salidas:
  pinMode(CO,INPUT);
  pinMode(IN,INPUT);
  pinMode(AG,INPUT);
  pinMode(AL,INPUT);

  digitalWrite(CO,LOW);
  digitalWrite(IN,LOW);
  digitalWrite(AG,LOW);
  digitalWrite(AL,LOW);
}

void loop() {
 //Envio de mensaje de alerta por CO a traves de APP:
  if(digitalRead(CO) == HIGH) {
    Serial.println("MONOXIDO");

    enviarMensaje("ALERTA POR CO","Se ha activado la electroválvula de gas");
    delay(20000);
    
  }
 //Envio de mensaje de alerta por inundación a traves de APP:
  else if(digitalRead(AG) == HIGH) {
    Serial.println("AGUA");

    enviarMensaje("ALERTA POR INUNDACIÓN","Se ha activado la electroválvula del agua");
    delay(20000);
 //Envio de mensaje de alerta por CO2 a traves de APP:   
  }
  else if(digitalRead(IN) == HIGH) {
    Serial.println("INCENDIO");

    enviarMensaje("ALERTA POR INCENDIO","Se han activado los dispositivos antiincendios");
    delay(20000);
    
  }
 //Envio de mensaje de alerta por intruso a traves de APP + comandos AT para realizar llamada a usuario:
  else if(digitalRead(AL) == HIGH) {
    Serial.println("INTRUSO");

    enviarMensaje("ALERTA POR INTRUSO","Se ha activado la alarma antiintrusos");
    delay(20000);

    mySerial.begin(115200);

    serial.println("Initializing..."); 
    delay(1000);

    mySerial.println("AT"); //una vez que las pruebas son exitosas regresará un OK 
    updateSerial();

    mySerial.println("ATD+ +34689402048;"); //  cambia ZZ con el codigo del paiz  y xxxxxxxxxxx con el numero de dígitos de el telefono 
    updateSerial();
    delay(20000); // espera por 20 segundos ...
    mySerial.println("ATH"); //cuelga
    updateSerial();
    
  }

  delay(100);
}
//Función para enviar mensajes via APP
const char* host = "api.pushbullet.com"; 
void enviarMensaje(String titulo,String mensaje) {
  
  WiFiClientSecure client;
  client.setInsecure();
  if(!client.connect(host,443)) {
    Serial.println("No se pudo conectar con el servidor");
    return;
  }

String url = "/v2/pushes";
  String message = "{\"type\": \"note\", \"title\": \""+titulo+"\", \"body\": \""+mensaje+"\"}\r\n";
  Serial.print("requesting URL: ");
  Serial.println(url);
  //send a simple note
  client.print(String("POST ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" +
               "Authorization: Bearer " + apiKey + "\r\n" +
               "Content-Type: application/json\r\n" +
               "Content-Length: " +
               String(message.length()) + "\r\n\r\n");
  client.print(message);

  delay(2000);
  while (client.available() == 0);

  while (client.available()) {
    String line = client.readStringUntil('\n');
    Serial.println(line);
  }  
}
